--map engine

--map creation and drawing
function matrix_map(map_h,map_w) --arguments = map table
    map = {}   -- create the matrix
    for y=o.y,map_h do
        map[y] = {}  -- create a new row
        for x=o.x,map_w do
            map[y][x] = 0
        end
    end
	return map
end

function matrix_wall(start_y,fin_y,start_x,fin_x,map)
	for y=start_y, fin_y do 
		for x=start_x, fin_x do 
		    map[y][x] = 1 
		end
	end
end

function matrix_draw(map)
    --for rows,columns x,y until no of indexes do 
	for y=o.y, #map do 
        for x=o.x, #map[y] do 
            if map[y][x] == 0 then	
                love.graphics.rectangle("line",x*tile.w,y*tile.h,tile.w,tile.h)
			elseif map[y][x] == 1 then	
                love.graphics.rectangle("fill",x*tile.w,y*tile.h,tile.w,tile.h)
            end
        end
    end	
end

--collision	
function checktile(event_x,event_y,map_x,map_y) --arguments = map_x,map_y co-ords, map table
    if matrix_world[(math.floor(event_y/tile.h)) + map_y][(math.floor(event_x/tile.w)) + map_x] == 1 then
    return false --collision tile in location map_x,map_y
    end
    return true --free space 
end

function withmap(unit_y,unit_x,map)
    local uy,ux = math.floor(unit_y/tile.h),math.floor(unit_x/tile.w)
    if (uy > #map or uy < o.y) or (ux > #map[o.y] or ux < o.x) then
    return false --out of bounds
    end	
	return true --within the map bounds
end
	