--[[Ekamu's Grid Movement System v0.3]]

--require scripts
tile = {w = 32,h = 32} --super_global tile width and height
o = {x = 0,y = 0} --super_global map origin x and y
require "includes/map"
require "includes/event"
require "editmode/mapedit" 
--game skeleton
function love.load()
--load
matrix_world = matrix_map(18,24)
origin = {
birth_x = o.x,
birth_y = o.y,
death_x = #matrix_world[o.y],
death_y = #matrix_world,
}
matrix_wall(origin.death_y,origin.death_y,origin.birth_x,origin.death_x,matrix_world)
--background
love.graphics.setBackgroundColor(0,0,0)
end

function love.update(dt)
mx = love.mouse.getX()
my = love.mouse.getY()
mouse_edit(matrix_world)
--player movement
    --if withmap(math.floor(player.y/tile.h),o.y,matrix_world) then 
player_nextgrid(matrix_world) 
player.u_n,player.u_e,player.u_s,player.u_w = dir_nest(player.grid_x,player.grid_y)
player.f_x,player.f_y = fixed_floor(player.grid_x,player.grid_y)
player_bounds(matrix_world);--limits player within map
    if not grid_check(player.x,player.y,player.grid_x,player.grid_y) then	
        player.move = true ; player_motion(dt) --move the player to next grid
    end
end

function love.draw()
--graphics
matrix_draw(matrix_world)
--player
love.graphics.setColor(255,0,0)
love.graphics.rectangle("fill",player.x,player.y,player.w,player.h)
love.graphics.rectangle("line",player.grid_x,player.grid_y,player.w,player.h)
love.graphics.setColor(0,255,255)
love.graphics.rectangle("line",player.f_x,player.u_n,player.w,player.h)--north
love.graphics.rectangle("line",player.u_e,player.f_y,player.w,player.h)--east
love.graphics.rectangle("line",player.f_x,player.u_s,player.w,player.h)--south
love.graphics.rectangle("line",player.u_w,player.f_y,player.w,player.h)--west
love.graphics.setColor(255,255,255)

end


